// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0
// source: personnels.sql

package db

import (
	"context"
)

const createPersonnel = `-- name: CreatePersonnel :one
INSERT INTO personnels (
    name,
    email,
    profession,
    department,
    service_id,
    user_id
) VALUES (
    $1, $2, $3, $4, $5, $6
) RETURNING id, name, email, profession, department, service_id, user_id
`

type CreatePersonnelParams struct {
	Name       string `json:"name"`
	Email      string `json:"email"`
	Profession string `json:"profession"`
	Department string `json:"department"`
	ServiceID  int64  `json:"service_id"`
	UserID     int64  `json:"user_id"`
}

func (q *Queries) CreatePersonnel(ctx context.Context, arg CreatePersonnelParams) (Personnels, error) {
	row := q.db.QueryRowContext(ctx, createPersonnel,
		arg.Name,
		arg.Email,
		arg.Profession,
		arg.Department,
		arg.ServiceID,
		arg.UserID,
	)
	var i Personnels
	err := row.Scan(
		&i.ID,
		&i.Name,
		&i.Email,
		&i.Profession,
		&i.Department,
		&i.ServiceID,
		&i.UserID,
	)
	return i, err
}

const deletePersonnel = `-- name: DeletePersonnel :exec
DELETE FROM personnels WHERE id = $1
`

func (q *Queries) DeletePersonnel(ctx context.Context, id int64) error {
	_, err := q.db.ExecContext(ctx, deletePersonnel, id)
	return err
}

const getPersonnel = `-- name: GetPersonnel :one
SELECT id, name, email, profession, department, service_id, user_id FROM personnels
WHERE id = $1 LIMIT 1
`

func (q *Queries) GetPersonnel(ctx context.Context, id int64) (Personnels, error) {
	row := q.db.QueryRowContext(ctx, getPersonnel, id)
	var i Personnels
	err := row.Scan(
		&i.ID,
		&i.Name,
		&i.Email,
		&i.Profession,
		&i.Department,
		&i.ServiceID,
		&i.UserID,
	)
	return i, err
}

const listPersonnels = `-- name: ListPersonnels :many
SELECT id, name, email, profession, department, service_id, user_id FROM personnels
ORDER BY id
LIMIT $1
OFFSET $2
`

type ListPersonnelsParams struct {
	Limit  int64 `json:"limit"`
	Offset int64 `json:"offset"`
}

func (q *Queries) ListPersonnels(ctx context.Context, arg ListPersonnelsParams) ([]Personnels, error) {
	rows, err := q.db.QueryContext(ctx, listPersonnels, arg.Limit, arg.Offset)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Personnels
	for rows.Next() {
		var i Personnels
		if err := rows.Scan(
			&i.ID,
			&i.Name,
			&i.Email,
			&i.Profession,
			&i.Department,
			&i.ServiceID,
			&i.UserID,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updatePersonnel = `-- name: UpdatePersonnel :exec
UPDATE personnels 
SET email = $2
WHERE id = $1
`

type UpdatePersonnelParams struct {
	ID    int64  `json:"id"`
	Email string `json:"email"`
}

func (q *Queries) UpdatePersonnel(ctx context.Context, arg UpdatePersonnelParams) error {
	_, err := q.db.ExecContext(ctx, updatePersonnel, arg.ID, arg.Email)
	return err
}
